unit CabCheckBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TCabCheckBox = class(TCheckBox)
  private
    { Private declarations }
    FEnterAsTab : Boolean;
    function GetEnterAsTab : Boolean;
    procedure SetEnterAsTab(Value : Boolean);
  protected
    { Protected declarations }
    procedure KeyPress(var Key: Char); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
  public
    { Public declarations }
  published
    { Published declarations }
    property EnterAsTab : Boolean read GetEnterAsTab
       write SetEnterAsTab;
  end;

procedure Register;

implementation

procedure TCabCheckBox.KeyPress(var Key: Char);
var
   MYForm: TCustomForm;
begin
   if FEnterAsTab and (Key = #13) then begin
       MYForm := GetParentForm( Self );
       if not (MYForm = nil ) then
           SendMessage(MYForm.Handle, WM_NEXTDLGCTL, 0, 0);
       Key := #0;
   end;
   if Key <> #0 then
      inherited KeyPress(Key);
end;

procedure TCabCheckBox.KeyDown(var Key: Word; Shift: TShiftState);
var
   MYForm: TCustomForm;
   CtlDir: Word;
begin
   if (Key = VK_UP) or (Key = VK_DOWN) then begin
      MYForm := GetParentForm( Self );
      if Key = VK_UP then
         CtlDir := 1
      else
         CtlDir :=0;
      if not (MYForm = nil ) then
         SendMessage(MYForm.Handle, WM_NEXTDLGCTL, CtlDir, 0);
   end
   else
      inherited KeyDown(Key, Shift);
end;

function TCabCheckBox.GetEnterAsTab : Boolean;
begin
   Result := FEnterAsTab;
end;

procedure TCabCheckBox.SetEnterAsTab(Value : Boolean);
begin
   FEnterAsTab := Value;
end;

procedure Register;
begin
  RegisterComponents('Cabarrus Components', [TCabCheckBox]);
end;

end.
